Subject: 24.5; python mode: fill-paragraph with raw docstring ignores python-fill-docstring-style
From: John Palmieri <[email-masked]>
To: [email-masked]
Date: Wed, 28 Oct 2015 12:16:20 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

To recreate the bug, in Python mode, type

def f():
    r"""
    This is the docstring for my function.

    It's a raw docstring because I want to type \t here, and maybe \n,
    for example in LaTeX code like \tau or \nu.

    More docstring here.
    """
    pass

Now with the cursor in the first sentence of the docstring, running
fill-paragraph ignores the setting of python-fill-docstring-style, I think
because Emacs doesn't detect that r""" is the start of the  docstring.
Similarly, running fill-paragraph in the last sentence behaves badly. Also
similarly, I think that it should be valid to begin a docstring with b"""
or u""" (and possibly some combination of b, r, u, before """, although I'm
not sure), and these also don't behave correctly.

In GNU Emacs 24.5.1 (x86_64-apple-darwin13.4.0, NS apple-appkit-1265.21)
 of 2015-04-10 on builder10-9.porkrind.org
Windowing system distributor `Apple', version 10.3.1348
Configured using:
 `configure --with-ns '--enable-locallisppath=/Library/Application
 Support/Emacs/${version}/site-lisp:/Library/Application
 Support/Emacs/site-lisp''

Important settings:
  value of $LANG: C
  locale-coding-system: utf-8-unix

Major mode: Outline

Minor modes in effect:
  goto-address-mode: t
  TeX-PDF-mode: t
  tooltip-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  buffer-read-only: t
  line-number-mode: t
  auto-fill-function: do-auto-fill
  transient-mark-mode: t
  view-mode: t